***main Programm for equal QDs
Off statistics;
function [Q],[N],[b+],[v],[v+],[b],[L+],[L],D,EV,DD,L,R;
Cfunction ev,first,eps,hq,om,kappa,g,gst,gammam,gammarc,gammarv,gammasps,gammaspp,gammad,pcv,evv,dd,dummy,d(symmetric),conj;
symbol N,M,u,a,number;
index i,j,k,l,m,n,o,p,q,r,s,t;
set bose: [b+],[N],[b];
set operator: [b+],[N],[b],[Q],L,R;
set prefactor: g,gst,eps,pcv,kappa,gammam,gammarc,gammarv,gammasps,gammaspp,gammad;




***preliminaries definition of the problem*************************************

***define the number of emitters
***define the number of QD correlations and the number of photonic correlations
***simplification for subsystems with the same properties are in line 94,109,118-120 and in procedure #allqdsareequal

#define NQD "2"  ***number of QD or 2 is needed when #allqdsareequal is used
#define CoN "6"  ***number of configurations in the QD
#define QDC "1"  ***QD correlations taken into account
#define PhC "10" ***photon correlations taken into account
#define NLT "12" ***number of Lindblad terms per QD defined in #QDlindbladt
#define NPM "1"  ***number of photon modes, current version works only for 1

***definition of the Hamiltonian
***note that the Hamiltonian depends also on CoN 
local [H0]=sum_(M,1,'NQD',sum_(N,1,'CoN',eps(M,N)*[Q](M,N,N)));      
local [Hph]=hq*om*[b+]*[b];    
local [HD]=sum_(M,1,'NQD',i_*(-gst(M,1)*[b]*[Q](M,2,1)+g(M,1)*[b+]*[Q](M,1,2)))+sum_(M,1,'NQD',i_*(-gst(M,1)*[b]*[Q](M,6,5)+g(M,1)*[b+]*[Q](M,5,6)));
local [H]=[H0]+[Hph]+[HD];

***definition of the Lindblad therms for each QD
#call QDlindbladterms('NQD')
.sort

***definition of the desired quantities***************
***A is the argument of the photon correlation function [N](A)=[b+]^A[b]^A i.e. the maximum photon operators
***I,L,M are the arguments of the quantum dot correlation function 


#do A=0,('PhC')/2

    local [d[N]('A')]=ev([N]('A'));

#enddo
***************First order in the QD correlations i.e. QDC
#do A=0,('PhC')/2-1
   #do I=1,(1)
        #do L=1,('CoN')
        #do M=1,('CoN')
            local [dev([N]('A'),[Q]('I','L','M'))]=ev([N]('A'),[Q]('I','L','M'));
            local [dev([b+],[N]('A'),[Q]('I','L','M'))]=ev([b+],[N]('A'),[Q]('I','L','M'));
        #enddo
        #enddo
   #enddo
.sort
#enddo
#do A=0,('PhC')/2-2
   #do I=1,(1)
        #do L=1,('CoN')
        #do M=1,('CoN')
            local [dev([b+],[b+],[N]('A'),[Q]('I','L','M'))]=ev([b+],[b+],[N]('A'),[Q]('I','L','M'));
        #enddo
        #enddo
   #enddo
.sort
#enddo


****************************************************************************



***eliminate all unnecessary terms 
***eliminate zero terms
id ev(?a,[N](0),?b)=ev(?a,?b);
#call constraints(ev,EV,'CoN')

***eliminate terms not in the defined order of approximation
#call countandneglect('PhC','QDC')

***apply the generalized Heisenberg equation
#call derivative('NQD','NLT','NPM')

***establish standard order according to the commutation relations defined in the procedure standardorder
#call standardorder
#call linearfunction(ev)


***!!! only necessary if  #allqdsareequal is used
***simplification for subsystems with the same properties
id ev(?a,[Q](?b),[Q](?c))=(number-1)*ev(?a,[Q](?b),[Q](?c));


***cluster approximation
#call Natobkb
#call expectationvaluetableQDC'QDC'PhC'PhC'
#call bkbtoNa

***eliminate zero terms that were produced by the factorization
#call constraints(ev,EV,'CoN')

***Substitutes quantities of which the conjugate already exists 
   #call conjugator('CoN')

***simplification for subsystems with the same properties
#call allqdsareequal

***eliminate zero terms – dummy variables 
id dummy(?a)=0;

.sort

***simplification for subsystems with the same properties
***the factor number/2 is needed because NQD==2
#do A=0,('PhC')/2
    local [d[N]('A')]=[d[N]('A')]*number/2+2*'A'*ev([N]('A'))*kappa*(number/2-1);
#enddo

.sort

print +s;
.end
