#procedure QDlindbladterms(NQD)
***input:  number of quantum dots NQD	
***output: definition of the Lindblad terms that are used in #procedure derivative


***pump

#do I=1,('NQD')
local [L+'I']=pcv('I')*[Q]('I',1,5);
local [L'I']=[Q]('I',5,1);
#enddo

#do I='NQD'+1,2*'NQD'
local [L+'I']=pcv('I'-'NQD')*[Q]('I'-'NQD',2,6);
local [L'I']=[Q]('I'-'NQD',6,2);
#enddo

***scattering in the conduction band

#do I=2*'NQD'+1,3*'NQD'
local [L+'I']=gammarc('I'-2*'NQD')*[Q]('I'-2*'NQD',3,2);
local [L'I']=[Q]('I'-2*'NQD',2,3);
#enddo


#do I=3*'NQD'+1,4*'NQD'
local [L+'I']=gammarc('I'-3*'NQD')*[Q]('I'-3*'NQD',5,4);
local [L'I']=[Q]('I'-3*'NQD',4,5);
#enddo

***scattering in the valence band

#do I=4*'NQD'+1,5*'NQD'
local [L+'I']=gammarv('I'-4*'NQD')*[Q]('I'-4*'NQD',4,2);
local [L'I']=[Q]('I'-4*'NQD',2,4);
#enddo


#do I=5*'NQD'+1,6*'NQD'
local [L+'I']=gammarv('I'-5*'NQD')*[Q]('I'-5*'NQD',5,3);
local [L'I']=[Q]('I'-5*'NQD',3,5);
#enddo

***spontaneous emission of s-shell

#do I=6*'NQD'+1,7*'NQD'
local [L+'I']=gammasps('I'-6*'NQD')*[Q]('I'-6*'NQD',2,1);
local [L'I']=[Q]('I'-6*'NQD',1,2);
#enddo

#do I=7*'NQD'+1,8*'NQD'
local [L+'I']=gammasps('I'-7*'NQD')*[Q]('I'-7*'NQD',6,5);
local [L'I']=[Q]('I'-7*'NQD',5,6);
#enddo

***spontaneous emission of p-shell

#do I=8*'NQD'+1,9*'NQD'
local [L+'I']=gammaspp('I'-8*'NQD')*[Q]('I'-8*'NQD',5,1);
local [L'I']=[Q]('I'-8*'NQD',1,5);
#enddo

#do I=9*'NQD'+1,10*'NQD'
local [L+'I']=gammaspp('I'-9*'NQD')*[Q]('I'-9*'NQD',6,2);
local [L'I']=[Q]('I'-9*'NQD',2,6);
#enddo

***direct dephasing

#do I=10*'NQD'+1,11*'NQD'+1
local [L+'I']=gammad*([Q]('I'-10*'NQD',2,2)+[Q]('I'-10*'NQD',4,4)+[Q]('I'-10*'NQD',6,6));
local [L'I']=[Q]('I'-10*'NQD',2,2)+[Q]('I'-10*'NQD',4,4)+[Q]('I'-10*'NQD',6,6);
#enddo

#do I=11*'NQD'+1,12*'NQD'
local [L+'I']=gammad*([Q]('I'-11*'NQD',3,3)+[Q]('I'-11*'NQD',5,5)+[Q]('I'-11*'NQD',6,6));
local [L'I']=([Q]('I'-11*'NQD',3,3)+[Q]('I'-11*'NQD',5,5)+[Q]('I'-11*'NQD',6,6));
#enddo


***cavity losses

#do I=12*'NQD'+1,12*'NQD'+1
local [L+'I']=kappa*[b+];
local [L'I']=[b];
#enddo



#endprocedure
