#procedure conjugator(CoN)
***input:	number of QD configurations 'CoN'
***output: 	expectation values with a photon annihilation operator are reformulated as their conjugate expressions to minimize the number of needed equations
***		ev([b],[Q](i,2,1)) -> conj(ev([b+],[Q](i,1,2)))
***state of local: 	normal ordered expectation values(ev) of [b] and [Q] operators separated by commas
***needs:		Cfunktion: conj

id ev([b](?b),[Q](i?,j?,k?))=conj(ev([b+](?b),[Q](i,k,j)));
id ev([N](?a),[b](?b),[Q](i?,j?,k?))=conj(ev([b+](?b),[N](?a),[Q](i,k,j)));

id ev([b](?b),[b](?c),[Q](i?,j?,k?))=conj(ev([b+](?b),[b+](?c),[Q](i,k,j)));
id ev([N](?a),[b](?b),[b](?c),[Q](i?,j?,k?))=conj(ev([b+](?b),[b+](?c),[N](?a),[Q](i,k,j)));


id ev([b](?b),[Q](i?,j?,k?),[Q](l?,m?,n?))=conj(ev([b+](?b),[Q](i,k,j),[Q](l,n,m)));
id ev([N](?a),[b](?b),[Q](i?,j?,k?),[Q](l?,m?,n?))=conj(ev([b+](?b),[N](?a),[Q](i,k,j),[Q](l,n,m)));
id ev([b](?b),[b](?c),[Q](i?,j?,k?),[Q](l?,m?,n?))=conj(ev([b+](?b),[b+](?c),[Q](i,k,j),[Q](l,n,m)));
id ev([N](?a),[b](?b),[b](?c),[Q](i?,j?,k?),[Q](l?,m?,n?))=conj(ev([b+](?b),[b+](?c),[N](?a),[Q](i,k,j),[Q](l,n,m)));


id ev([b](?b),[Q](i?,j?,k?),[Q](l?,m?,n?),[Q](o?,p?,q?))=conj(ev([b+](?b),[Q](i,k,j),[Q](l,n,m),[Q](o,q,p)));
id ev([N](?a),[b](?b),[Q](i?,j?,k?),[Q](l?,m?,n?),[Q](o?,p?,q?))=conj(ev([b+](?b),[N](?a),[Q](i,k,j),[Q](l,n,m),[Q](o,q,p)));
id ev([b](?b),[b](?c),[Q](i?,j?,k?),[Q](l?,m?,n?),[Q](o?,p?,q?))=conj(ev([b+](?b),[b+](?c),[Q](i,k,j),[Q](l,n,m),[Q](o,q,p)));
id ev([N](?a),[b](?b),[b](?c),[Q](i?,j?,k?),[Q](l?,m?,n?),[Q](o?,p?,q?))=conj(ev([b+](?b),[b+](?c),[N](?a),[Q](i,k,j),[Q](l,n,m),[Q](o,q,p)));
id ev([b](?b),[b](?c),[b](?d),[Q](i?,j?,k?),[Q](l?,m?,n?),[Q](o?,p?,q?))=conj(ev([b+](?b),[b+](?c),[b+](?d),[Q](i,k,j),[Q](l,n,m),[Q](o,q,p)));
id ev([N](?a),[b](?b),[b](?c),[b](?d),[Q](i?,j?,k?),[Q](l?,m?,n?),[Q](o?,p?,q?))=conj(ev([b+](?b),[b+](?c),[b+](?d),[N](?a),[Q](i,k,j),[Q](l,n,m),[Q](o,q,p)));


#do K=1,('CoN')
#do L=1,('CoN')
	#if ('K'>'L')
		id ev([Q](i?,'K','L'),[Q](j?,m?,n?))=conj(ev([Q](i,'L','K'),[Q](j,n,m)));
		id ev([N](?a),[Q](i?,'K','L'),[Q](j?,m?,n?))=conj(ev([N](?a),[Q](i,'L','K'),[Q](j,n,m)));
		id ev([Q](i?,'K','L'),[Q](j?,m?,n?),[Q](o?,p?,q?))=conj(ev([Q](i,'L','K'),[Q](j,n,m),[Q](o,q,p)));
		id ev([N](?a),[Q](i?,'K','L'),[Q](j?,m?,n?),[Q](o?,p?,q?))=conj(ev([N](?a),[Q](i,'L','K'),[Q](j,n,m),[Q](o,q,p)));
	#endif
			
#enddo
#enddo


#endprocedure
