#procedure constraints(f,ff,CoN)
***input:	commutative function f of operators divided by commas
***		noncommutative function ff of operators divided by commas
***		number of configurations to determine the number of excitations in the expectation value
***output:	same as the input function but now: excitation, particle preserving, angular momentum preserving  
***ev([b+]*...*[b]*[Q]*...*[Q]) -> 0 if conditions matches
***local state:	expectation values of operators divided by commas
#call Natobkb
#call commatoproduct('f','ff')

***Balanced amount of creation and annihilation operators

argument 'f';
	if ((count([b+],1,[b],-1)!=0)&&(count([Q],1)==0)) discard;
endargument;


***conservation laws
***list of transitions depending on the Configuration Number CoN

argument 'f';
	id [Q](i?,j?,2)= [Q](i,j,2)*[v+];
	id [Q](i?,j?,3)= [Q](i,j,3)*[v+];
	id [Q](i?,j?,4)= [Q](i,j,4)*[v+];
	id [Q](i?,j?,5)= [Q](i,j,5)*[v+];
	id [Q](i?,j?,6)= [Q](i,j,6)*[v+]*[v+];	

	id [Q](i?,2,j?)= [Q](i,2,j)*[v];
	id [Q](i?,3,j?)= [Q](i,3,j)*[v];
	id [Q](i?,4,j?)= [Q](i,4,j)*[v];
	id [Q](i?,5,j?)= [Q](i,5,j)*[v];
	id [Q](i?,6,j?)= [Q](i,6,j)*[v]*[v];	
endargument;


argument 'f';
	if (count([b+],1,[b],-1)!=count([v+],1,[v],-1)) discard;
endargument;

argument 'f';
id [v]=1;
id [v+]=1;
endargument;

id 'f'(0)=0;

#call producttocomma('f','ff')
#call bkbtoNa

***selection rules

argument 'f';
	
	id [Q](i?,j?,3)= [Q](i,j,3)*[v]*[v];
	id [Q](i?,j?,4)= [Q](i,j,4)*[v+]*[v+];
	
	id [Q](i?,3,j?)= [Q](i,3,j)*[v+]*[v+];
	id [Q](i?,4,j?)= [Q](i,4,j)*[v]*[v];
	
endargument;


argument 'f';
	if (count([v+],1,[v],-1)!=0) discard;
endargument;

argument 'f';
id [v]=1;
id [v+]=1;
endargument;


id ev(?a,0,?b)=0;


#endprocedure
