***createclustertable
***this program generates cluster tables that are used to increase the efficiency of main programm EoM_main.frm
***the output of this program is turned into a procedure with the perl script createclustertable.pl
***all types of expectation values that need to be factorized need to be defined here
***the order of the approximation is defined by QDC and PhC 		
***output:	ev([b+],...,[b+],[b],...,[b],[Q],...,[Q]) -> SUM PROD  ev([b+],...,[b+],[b],...,[b],[Q],...,[Q])
***		           PhC -times         QDC-times                       <PhC -times            <QDC-times 
Off statistics;
function [bA],[bB],[bC],[bD],[bE],[bF],[Q],[N],[b+],[b],EV,CF,L,R;
Cfunction first,ev,cf;
index i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z;
symbol a;



#define QDC "1" ***QD correlations
#define PhC "4" ***Photon Correlations


***define the types of expectation values that need to be substituted for the various orders
***if QDC>1 these definitions need to be extended 
***new
#do A=0,'PhC'/2
local [idev(N{'A'},[Q](i,j,k))]=ev([N]('A'),[Q](i,j,k));
local [idev([b+],N{'A'},[Q](i,j,k))]=ev([b+],[N]('A'),[Q](i,j,k));
local [idev(N{'A'},[b],[Q](i,j,k))]=ev([N]('A'),[b],[Q](i,j,k));
#enddo
#do A=0,'PhC'/2-1
local [idev(N{'A'},[Q](i,j,k),[Q](l,m,n))]=ev([N]('A'),[Q](i,j,k),[Q](l,m,n));
local [idev([b+],N{'A'},[Q](i,j,k),[Q](l,m,n))]=ev([b+],[N]('A'),[Q](i,j,k),[Q](l,m,n));
local [idev(N{'A'},[b],[Q](i,j,k),[Q](l,m,n))]=ev([N]('A'),[b],[Q](i,j,k),[Q](l,m,n));
local [idev([b+],[b+],N{'A'},[Q](i,j,k))]=ev([b+],[b+],[N]('A'),[Q](i,j,k));
local [idev(N{'A'},[b],[b],[Q](i,j,k))]=ev([N]('A'),[b],[b],[Q](i,j,k));
#enddo
#do A=0,'PhC'/2-2
local [idev([b+],[b+],N{'A'},[Q](i,j,k),[Q](l,m,n))]=ev([b+],[b+],[N]('A'),[Q](i,j,k),[Q](l,m,n));
local [idev([b+],[b+],[b+],N{'A'},[Q](i,j,k),[Q](l,m,n))]=ev([b+],[b+],[b+],[N]('A'),[Q](i,j,k),[Q](l,m,n));
local [idev(N{'A'},[b],[b],[Q](i,j,k),[Q](l,m,n))]=ev([N]('A'),[b],[b],[Q](i,j,k),[Q](l,m,n));
local [idev(N{'A'},[b],[b],[b],[Q](i,j,k),[Q](l,m,n))]=ev([N]('A'),[b],[b],[b],[Q](i,j,k),[Q](l,m,n));
#enddo




#call commatoproduct(ev,EV)
argument;
id [N](0)=1;
id [N](a?)=[b+]^a*[b]^a;
endargument;
#call producttocomma(ev,EV)


***perform clusterexpansion (CE)
***factorization

id ev(?a)=L*EV(?a)*R;

#do i=1,42
	id EV([b+]?(?b),?a)=EV(first*[b+](?b),?a);
	id EV(first*[b+]?(?b),?a)=distrib_(0,2,EV,CF,first*[b+](?b),?a);
	id EV=1;
	id CF=1; 
	id EV(?a,first*[b+]?(?c),?b)=0;
	argument;
		id first=1;
	endargument;
	.sort
#enddo

id L=1;
id R=1;
id CF(?a)=cf(?a);

***********************************************************************
***approximations
***neglects the correlation functions with larger operator number than defined in QDC and PhC
#call commatoproduct(cf,CF)

argument cf;
	if (count([Q],1)>'QDC') discard;
	if (count([b+],1,[b],1,[Q],1)>'PhC') discard;
endargument;

id cf(0)=0;

#call producttocomma(cf,CF)
****************************************************************************

***re-factorization
***turns the correlation functions back into expectation values
***when no approximation is made the locals should be identical to the input 
id cf(?a)=L*CF(?a)*R;

#do i=1,42
	id CF([b+]?(?b),?a)=CF(first*[b+](?b),?a);
	id CF(first*[b+]?(?b),?a)=-distrib_(0,2,EV,CF,first*[b+](?b),?a)+EV([b+](?b),?a)+CF([b+](?b),?a);
	id EV=1;
	id CF=1; 
	id EV(?a,first*[b+]?(?c),?b)=0;
	argument;
		id first=1;
	endargument;
	.sort
#enddo

id L=1;
id R=1;
id EV(?a)=ev(?a);

***balanced amount of creation and annihilation operators

#call commatoproduct(ev,EV)
argument ev;
	if ((count([b+],1,[b],-1)!=0)&&(count([Q],1)==0)) discard;
endargument;
id ev(0)=0;
#call producttocomma(ev,EV)


.sort
print +s;
.end
