#procedure derivative(NQD,NLT,NPM)
***input:	NQD number of quantum dots
***		NLT number of Lindblad terms per Quantum dot
***		NPM number of photon modes
***output:	derivative of the expectation values according to the generalized Heisenberg equation - but not in standard order separated by dummy operators L and R
***		ev([a1],...,[xn]) -> L*{[a1]*...*[xn];H}*R +L*Lindblad([a1]*...*[xn])*R
***needs:	Hamiltonian [H],Lindblad terms defined in #procedure QDlindbladt


id ev(?a)=L*D*EV(?a)*R;

id D*EV(?a)=i_*([H]*EV(?a)-EV(?a)*[H])+sum_(u,1,'NLT'*'NQD'+'NPM',2*[L+](u)*EV(?a)*[L](u)-[L+](u)*[L](u)*EV(?a)-EV(?a)*[L+](u)*[L](u));

#do v=1,'NLT'*'NQD'+'NPM'
	id [L+]('v')=[L+{'v'}];
	id [L]('v')=[L{'v'}];
#enddo


#call outfunction(EV,EV)


#endprocedure
